/**
 * @(#) AccessCumulativeIP.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */
import java.io.*;
import java.sql.*;
import java.util.*;
import org.jsn.reqanalysis.db.*;

public class AccessCumulativeIP{

  private static java.text.SimpleDateFormat formater = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat formater2 = new java.text.SimpleDateFormat("yyyy-MM-dd-HH.mm.ss.000000");      
  private static java.text.SimpleDateFormat formater3 = new java.text.SimpleDateFormat("HH:mm");      
  public static void main(String[] args) throws Exception {
    if ( args.length < 3 ) {
        System.out.println("Usage: accesscumulativeip <starttime(yyyyMMdd/HHmmss)> <endtime yyyyMMdd/HHmmss)> <interval(seconds)> [<host>]");
        System.exit(1);
    }
    java.util.Date starttime = formater.parse(args[0]);
    java.util.Date endtime = formater.parse(args[1]);
    long interval = Long.parseLong(args[2]);
    interval *= 1000;
    String hostname = null;
    if ( args.length > 3 ) {
      hostname = args[3];
    }
    ConnectionResource resource = null;
    Connection conn = null;
    Statement stmt = null;
    PreparedStatement pstmt = null;
    try {
        resource = new ConnectionResource();
        conn = resource.getConnection();
        stmt = conn.createStatement();

        Vector hosts = new Vector();
        if ( hostname == null ) {
            ResultSet rs1 = stmt.executeQuery("select distinct host from accesslog order by host asc");
            while( rs1.next() ) {
                hosts.addElement(rs1.getString(1));
            }
            rs1.close();
        }
        else hosts.addElement(hostname);

        java.util.Date currenttime = new java.util.Date (starttime.getTime());

        HashSet totalip = new HashSet(6000);
        HashSet[] ips = new HashSet[hosts.size()];
        System.out.print("TIME");
        for(int i=0;i<hosts.size();i++) {
            System.out.print("\t"+ (String)hosts.elementAt(i));
            ips[i] = new HashSet(3000);
        }
        if ( hosts.size() > 1 ) System.out.println("\tTOTAL");
        else System.out.println();

        java.util.Date start = new java.util.Date (starttime.getTime());
        while(true) {
            java.util.Date end = new java.util.Date (start.getTime() + interval);
            System.out.print( formater3.format(end) );

            for(int i=0;i<hosts.size();i++){
                String host = (String)hosts.elementAt(i);
                String sql = 
                   "select distinct ip from accesslog" +
                   "    where  host='" + host + "'" +
                   "    and '" + formater2.format(start) + "' <= logtime" +
                   "    and logtime < '" +  formater2.format(end) + "'";

                ResultSet rs = stmt.executeQuery(sql);

                long count = 0L;
                while (rs.next()) {
                    String ip = rs.getString(1);
                    if ( ! ips[i].contains(ip) ) ips[i].add(ip);
                    if ( hosts.size() > 1 && ! totalip.contains(ip) ) totalip.add(ip);
                }
                rs.close();
                System.out.print( "\t" + ips[i].size()  );
            }
            if ( hosts.size() > 1 ) {
                System.out.print( "\t" + totalip.size()  );
            }

            System.out.println();


            if ( end.getTime() >= endtime.getTime() ) break;
            start = end;
        }
    }
    catch(Exception e){
        System.out.println(e.toString());
    }
    finally {
        if ( stmt != null ) try { stmt.close();}catch(Exception e){}
        if ( conn != null ) resource.release();
    }
    System.exit(0);
  }
}