/**
 * @(#) AccessSpecialLoad.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */
import java.io.*;
import java.sql.*;
import java.util.*;
import org.jsn.reqanalysis.db.*;

public class AccessSpecialLoad{

  private static java.text.SimpleDateFormat rdf = new java.text.SimpleDateFormat("dd/MM/yyyy:HH:mm:ss");      
  private static java.text.SimpleDateFormat df = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat formater2 = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");      
  public static void main(String[] args) throws Exception {
    if ( args.length < 2 ) {
        System.out.println("Usage: accessspecialload <access_log> <host> [drop]");
        System.exit(1);
    }

    ConnectionResource resource = null;
    Connection conn = null;
    Statement stmt = null;
    PreparedStatement pstmt = null;
    try {
        resource = new ConnectionResource();
        conn = resource.getConnection();
        stmt = conn.createStatement();
        if ( args.length >= 3 && args[2].equals("drop") ) {
           try{
               stmt.executeUpdate("drop index accesslog_idx1");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx2");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx3");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx4");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx5");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx6");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop table ACCESSLOG");
               System.out.println("Table ACCESSLOG droped");
           }
           catch(Exception e){}
           try{
              stmt.executeUpdate(
                "create table ACCESSLOG(" +
                " host varchar(15) not null, " +
                " ip varchar(15) not null , " +
                " starttime timestamp , " +
                " logtime timestamp not null, " +
                " elapsed num(10) , " +
                " url varchar(2000) not null," +
                " shorturl varchar(100), " + 
                " txid varchar(50), " + 
                " return_code char(3) not null," +
                " size num(10) not null)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx1 " +
                "ON ACCESSLOG(ip)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx2 " +
                "ON ACCESSLOG(host,logtime)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx3 " +
                "ON ACCESSLOG(logtime)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx4 " +
                "ON ACCESSLOG(host)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx5 " +
                "ON ACCESSLOG(shorturl)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx6 " +
                "ON ACCESSLOG(shorturl,txid)"
              );
              System.out.println("Table ACCESSLOG created");
           }
           catch(Exception e){
               System.out.println(e.toString());
           }
        }
        if ( stmt != null ) try{stmt.close();}catch(Exception e){}
        stmt = null;

        conn.setAutoCommit(false);
        pstmt = conn.prepareStatement(
               "insert into ACCESSLOG(host,ip,logtime,url,shorturl,txid,return_code,size,elapsed) "+
               "values(?,?,?,?,?,?,?,?,?)");
        File file = new File(args[0]);
        BufferedReader br = new BufferedReader(new FileReader(file));
        int commit_cnt = 0;
        for(String line = br.readLine();line != null; line=br.readLine() ){

            String host = args[1];
            String ip = null;
            java.util.Date logtime = null;
            String url = null;
            String shorturl = null;
            String txid= "";
            int return_code = 200;
            int size = 0;
            int elapsed = 0;
            StringTokenizer nizer = new StringTokenizer(line);
            try {
                nizer.hasMoreElements();
                ip = nizer.nextToken();//ip

                nizer.hasMoreElements();
                nizer.nextToken();// -

                nizer.hasMoreElements();
                nizer.nextToken();// -

                
                nizer.hasMoreElements();
                String tmp = nizer.nextToken();
                String month_str = tmp.substring(4,7);
                if (      month_str.equals("Jan") ) month_str = "01";
                else if ( month_str.equals("Feb") ) month_str = "02";
                else if ( month_str.equals("Mar") ) month_str = "03";
                else if ( month_str.equals("Apr") ) month_str = "04";
                else if ( month_str.equals("May") ) month_str = "05";
                else if ( month_str.equals("Jun") ) month_str = "06";
                else if ( month_str.equals("Jul") ) month_str = "07";
                else if ( month_str.equals("Aug") ) month_str = "08";
                else if ( month_str.equals("Sep") ) month_str = "09";
                else if ( month_str.equals("Oct") ) month_str = "10";
                else if ( month_str.equals("Nov") ) month_str = "11";
                else if ( month_str.equals("Dec") ) month_str = "12";

                String date_str = tmp.substring(1,3) + '/' + month_str + '/' + tmp.substring(8);
                logtime = rdf.parse(date_str);

                nizer.hasMoreElements();
                nizer.nextToken();// garvage

                nizer.hasMoreElements();
                nizer.nextToken();// GET/POST
                
                nizer.hasMoreElements();
                url= nizer.nextToken();

                //if ( url.indexOf(".gif") > -1 || url.indexOf(".jpg") > -1 || 
                //     url.indexOf(".css") > -1 || url.indexOf(".js\"") > -1 || 
                //     url.indexOf(".swf") > -1 )
                //    continue;
                //if ( url.indexOf("TEST") > 0 ) continue;
                //if ( url.startsWith("//") ) {
                //   url = url.substring(1);
                //}

                //if ( (url.indexOf("/servlet/") == -1) && (url.indexOf(".jsp") == -1) ) continue;

                // for ī
                //if ( url.endsWith(".txt") || url.endsWith(".class") ||
                //     url.endsWith(".vbs") || url.equals("/servlet/Main")  ) continue;
		
                // for 
                if ( url.equals("/NGBS/NDAdvisor") || url.equals("/")  ) continue;

                int index = url.indexOf("?");
                if ( index == -1 ) shorturl = url;
                else {
                   shorturl = url.substring(0,index);
                   //int x = url.indexOf("&");
                   //if ( x == -1 ) shorturl = url;
                   //else   shorturl = url.substring(0,x);

                   // txid ϱ
                   // "/NGBS/BrowserServlet?txid=crm.custopen.IndiRegist&key=value&..."
                   String params = url.substring(index+1);
                   StringTokenizer param_nizer = new StringTokenizer(params,"&");
                   while(param_nizer.hasMoreElements()){
                       String pair = param_nizer.nextToken();
                       int z = pair.indexOf("=");
                       if ( z > -1 ) { 
                           String key = pair.substring(0,z);
                           if ( key.equals("hdfActionID") || key.equals("txid") ) {
                               txid = pair.substring(z+1);
                               break;
                           }
                       }
                   }                       
                }

                nizer.hasMoreElements();
                nizer.nextToken();// garvage "HTTP/1.1""

                nizer.hasMoreElements();
                return_code = Integer.parseInt(nizer.nextToken());

                nizer.hasMoreElements();
                try{
                size = Integer.parseInt(nizer.nextToken());
                }catch(Throwable e){}

                // options
                if ( nizer.hasMoreElements() ) {
                    try{
                    elapsed = Integer.parseInt(nizer.nextToken());
                    }catch(Throwable e){}
                }
            }
            catch (Throwable e){
                System.out.println(e.toString());
                continue;
            }
            if ( commit_cnt % (80*6) == 0 ) {
                String tmpurl = ( url.length() > 20 )? url.substring(0,20) + "...": url;
                System.out.println("\n" + host + ":"+ ip + ":" + df.format(logtime) +":" + tmpurl + " " + return_code + " " + size + " " + elapsed);
            }
            else System.out.print('-');

            try{
                pstmt.clearParameters();
                pstmt.setString(1, host);
                pstmt.setString(2, ip);
                pstmt.setString(3, formater2.format(logtime));
                pstmt.setString(4, url);
                pstmt.setString(5, shorturl);
                pstmt.setString(6, txid);
                pstmt.setInt(7, return_code);
                pstmt.setInt(8, size);
                pstmt.setInt(9, elapsed);
                pstmt.executeUpdate();
                commit_cnt++;
                if ( commit_cnt % 5000 == 0 ) conn.commit();
            }
            catch(Throwable e){
                System.out.println(e.toString());
                continue;
            }

        }
    }
    catch(Exception e){
        System.out.println(e.toString());
    }
    finally {
        if ( conn != null ) try{conn.commit();}catch(Exception e){}
        if ( stmt != null ) try { stmt.close();}catch(Exception e){}
        if ( pstmt != null ) try { pstmt.close();}catch(Exception e){}
        if ( conn != null ) resource.release();
    }
    System.exit(0);
  }
}