/**
 * @(#) HostTxCalc.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */
import java.io.*;
import java.sql.*;
import java.util.*;
import org.jsn.reqanalysis.db.*;

public class HostTxCalc{

  private static java.text.SimpleDateFormat formater = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat formater2 = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");      
  public static void main(String[] args) throws Exception {
    if ( args.length < 3 ) {
        System.out.println("Usage: hosttxcalc <starttime(yyyyMMdd/HHmmss)> <endtime(yyyyMMdd/HHmmss)> <interval(seconds)> [<tx name>]");
        System.exit(1);
    }
    java.util.Date starttime = formater.parse(args[0]);
    java.util.Date endtime = formater.parse(args[1]);
    long interval = (long)( Double.valueOf(args[2]).doubleValue() * 1000.0 );
    String txname = null;
    if ( args.length > 3 ) {
      txname = args[3];
    }
    ConnectionResource resource = null;
    Connection conn = null;
    Statement stmt = null;
    PreparedStatement pstmt = null;
    try {


        resource = new ConnectionResource();
        conn = resource.getConnection();
        stmt = conn.createStatement();

        java.sql.Timestamp start = new java.sql.Timestamp(starttime.getTime());
        java.sql.Timestamp end = new java.sql.Timestamp(start.getTime() + interval);
        while(true) {
            String sql1 = 
                   "select count(*) " + 
                   " from HOSTTXLOG " +
                   " where '" + formater2.format(start) + "' <= logtime and logtime < '" +  formater2.format(end) + "' " +
                   " and direction = 'S' ";
            if ( txname != null ) sql1 += "and txname = '" + txname +"' ";
            ResultSet rs1 = stmt.executeQuery(sql1);
            int send_count = 0;
            if (rs1.next()) {
                send_count = rs1.getInt(1);
            }
            rs1.close();

            String sql2 = 
                   "select count(*) " + 
                   " from HOSTTXLOG " +
                   " where '" + formater2.format(start) + "' <= logtime and logtime < '" +  formater2.format(end) + "' " +
                   " and direction = 'R' ";
            if ( txname != null ) sql2 += "and txname = '" + txname +"' ";
            ResultSet rs2 = stmt.executeQuery(sql2);
            int receive_count = 0;
            if (rs2.next()) {
                receive_count = rs2.getInt(1);
            }
            rs2.close();

            int send_all_count = 0;
            int receive_all_count = 0;
            if ( txname != null ) {
                String sql3 = 
                       "select count(*) " + 
                       " from HOSTTXLOG " +
                       " where '" + formater2.format(start) + "' <= logtime and logtime < '" +  formater2.format(end) + "' " +
                       " and direction = 'S' ";
                ResultSet rs3 = stmt.executeQuery(sql3);
                if (rs3.next()) {
                    send_all_count = rs3.getInt(1);
                }
                rs3.close();

                String sql4 = 
                       "select count(*) " + 
                       " from HOSTTXLOG " +
                       " where '" + formater2.format(start) + "' <= logtime and logtime < '" +  formater2.format(end) + "' " +
                       " and direction = 'R' ";
                ResultSet rs4 = stmt.executeQuery(sql4);
                if (rs4.next()) {
                    receive_all_count = rs4.getInt(1);
                }
                rs4.close();
            }

            
            
            System.out.print( formater.format(start) + ","  + send_count + "," + receive_count );
            if ( txname != null ) {
                System.out.println("," + send_all_count + "," + receive_all_count );
            }
            else System.out.println();



            start = end;
            end = new java.sql.Timestamp(start.getTime() + interval);
            if ( end.getTime() > endtime.getTime() ) break;
        }
    }
    catch(Exception e){
        System.out.println(e.toString());
    }
    finally {
        if ( stmt != null ) try { stmt.close();}catch(Exception e){}
        if ( conn != null ) resource.release();
    }
    System.exit(0);
  }
}