/**
 * @(#) HostTxInsert.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */
import java.io.*;
import java.sql.*;
import java.util.*;
import org.jsn.reqanalysis.db.*;

public class HostTxLoad{

  private static java.text.SimpleDateFormat rdf = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");      
  private static java.text.SimpleDateFormat df = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat formater2 = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");      
  public static void main(String[] args) throws Exception {
    if ( args.length < 2 ) {
        System.out.println("Usage: hosttxload <load_file> [drop]");
        System.exit(1);
    }

    ConnectionResource resource = null;
    Connection conn = null;
    Statement stmt = null;
    PreparedStatement pstmt = null;
    try {
        resource = new ConnectionResource();
        conn = resource.getConnection();
        stmt = conn.createStatement();
        if ( args.length >= 2 && args[1].equals("drop") ) {
           try{
               stmt.executeUpdate("drop index HOSTTX_IDX");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop table HOSTTXLOG");
               System.out.println("Table HOSTTXLOG droped");
           }
           catch(Exception e){}
           try{
              stmt.executeUpdate(
                "create table HOSTTXLOG(" +
                " logtime timestamp not null, " +
                " direction char(1) not null, " +
                " txname varchar(20) not null)" 
              );
              stmt.executeUpdate(
                "create index HOSTTX_IDX " +
                "ON HOSTTXLOG(logtime,direction,txname)"
              );
              System.out.println("Table HOSTTXLOG created");
           }
           catch(Exception e){
           }
        }

        pstmt = conn.prepareStatement(
               "insert into HOSTTXLOG(logtime,direction,txname) "+
               "values(?,?,?)");

        File file = new File(args[0]);
        BufferedReader br = new BufferedReader(new FileReader(file));
        for(String line = br.readLine();line != null; line=br.readLine() ){
            java.util.Date logtime = null;
            String txname = null;
            String direction = null;
            StringTokenizer nizer = new StringTokenizer(line, "\t");
            try {
                nizer.hasMoreElements();
                direction = nizer.nextToken();// 'R' or 'S'

                nizer.hasMoreElements();
                logtime = rdf.parse(nizer.nextToken());// '2001-04-07 12:20:00'

                nizer.hasMoreElements();
                txname = nizer.nextToken();// tx name

            }
            catch (Exception e){
                System.out.println(e.toString());
                continue;
            }
            System.out.println(df.format(logtime) +":" + direction + ":" + txname);

            try{
                pstmt.clearParameters();
                pstmt.setString(1, formater2.format(logtime));
                pstmt.setString(2, direction);
                pstmt.setString(3, txname);
                pstmt.executeUpdate();
            }
            catch(Exception e){
                System.out.println(e.toString());
                continue;
            }

        }
    }
    catch(Exception e){
        System.out.println(e.toString());
    }
    finally {
        if ( stmt != null ) try { stmt.close();}catch(Exception e){}
        if ( pstmt != null ) try { pstmt.close();}catch(Exception e){}
        if ( conn != null ) resource.release();
    }
    System.exit(0);
  }
}