/**
 * @(#) JDFAccessLoad.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */
import java.io.*;
import java.sql.*;
import java.util.*;
import org.jsn.reqanalysis.db.*;

public class JDFAccessLoad{

  private static java.text.SimpleDateFormat rdf = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat df = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat formater2 = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");      
  public static void main(String[] args) throws Exception {
    if ( args.length < 2 ) {
        System.out.println("Usage: jdfaccessload <jdf_log> <host> [drop]");
        System.exit(1);
    }

    ConnectionResource resource = null;
    Connection conn = null;
    Statement stmt = null;
    PreparedStatement pstmt = null;
    try {
        resource = new ConnectionResource();
        conn = resource.getConnection();
        stmt = conn.createStatement();
        if ( args.length >= 3 && args[2].equals("drop") ) {
           try{
               stmt.executeUpdate("drop index accesslog_idx1");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx2");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx3");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index accesslog_idx4");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop table ACCESSLOG");
               System.out.println("Table ACCESSLOG droped");
           }
           catch(Exception e){}
           try{
              stmt.executeUpdate(
                "create table ACCESSLOG(" +
                " host varchar(15) not null, " +
                " ip varchar(15) not null , " +
                " starttime timestamp , " +
                " logtime timestamp not null, " +
                " elapsed num(10) , " +
                " url varchar(2000) not null," +
                " shorturl varchar(500), " + 
                " return_code char(3) not null," +
                " size num(10) not null)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx2 " +
                "ON ACCESSLOG(host,logtime)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx1 " +
                "ON ACCESSLOG(ip)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx3 " +
                "ON ACCESSLOG(logtime)"
              );
              stmt.executeUpdate(
                "create index accesslog_idx4 " +
                "ON ACCESSLOG(host)"
              );
              System.out.println("Table ACCESSLOG created");
           }
           catch(Exception e){
               System.out.println(e.toString());
           }
        }
        if ( stmt != null ) try{stmt.close();}catch(Exception e){}
        stmt = null;

        conn.setAutoCommit(false);
        pstmt = conn.prepareStatement(
               "insert into ACCESSLOG(host,ip,starttime, logtime,url,shorturl,return_code,size,elapsed) "+
               "values(?,?,?,?,?,?,?,?,?)");
        File file = new File(args[0]);
        BufferedReader br = new BufferedReader(new FileReader(file));
        int commit_cnt = 0;
        for(String line = br.readLine();line != null; line=br.readLine() ){

            if ( line == null ) continue;
            if ( line.indexOf("Servlet") == -1 ) continue;
            if ( line.indexOf("end") == -1 ) continue;


            String host = args[1];
            String ip = "";
            java.util.Date starttime = null;
            java.util.Date logtime = null;
            String url = null;
            String shorturl = null;
            int return_code = 200;
            int size = 0;
            int elapsed = 0;
            StringTokenizer nizer = new StringTokenizer(line);
            try {
                nizer.hasMoreElements();
                String time = nizer.nextToken();
                logtime = rdf.parse("20020227/" + time.substring(1));

                nizer.hasMoreElements();
                String url_tmp = nizer.nextToken();
                url = url_tmp.substring(1);
                shorturl = url;

                nizer.hasMoreElements();
                nizer.nextToken();// :
                
                nizer.hasMoreElements();
                nizer.nextToken();// thread #
                
                nizer.hasMoreElements();
                nizer.nextToken();// ?
                
                nizer.hasMoreElements();
                nizer.nextToken();// :
                
                nizer.hasMoreElements();
                nizer.nextToken();// end
                
                nizer.hasMoreElements();
                nizer.nextToken(); // (

                nizer.hasMoreElements();
                nizer.nextToken(); // elapsed

                nizer.hasMoreElements();
                nizer.nextToken(); // =

                nizer.hasMoreElements();
                try{
                    elapsed = Integer.parseInt(nizer.nextToken());
                }catch(Throwable e){}

                nizer.hasMoreElements();
                nizer.nextToken(); // )

                nizer.hasMoreElements();
                ip = nizer.nextToken(); // ip

                starttime = new java.util.Date( logtime.getTime() - elapsed );

            }
            catch (Throwable e){
                System.out.println(e.toString());
                continue;
            }
            if ( commit_cnt % (80*6) == 0 ) {
                String tmpurl = ( url.length() > 20 )? url.substring(0,20) + "...": url;
                System.out.println("\n" + host + ":"+ ip + ":" + df.format(logtime) +":" + tmpurl + " " + return_code + " " + size + " " + elapsed);
            }
            else System.out.print('-');

            try{
                pstmt.clearParameters();
                pstmt.setString(1, host);
                pstmt.setString(2, ip);
                pstmt.setString(3, formater2.format(logtime));
                pstmt.setString(4, formater2.format(logtime));
                pstmt.setString(5, url);
                pstmt.setString(6, shorturl);
                pstmt.setInt(7, return_code);
                pstmt.setInt(8, size);
                pstmt.setInt(9, elapsed);
                pstmt.executeUpdate();
                commit_cnt++;
                if ( commit_cnt % 5000 == 0 ) conn.commit();
            }
            catch(Throwable e){
                System.out.println(e.toString());
                continue;
            }

        }
    }
    catch(Exception e){
        System.out.println(e.toString());
    }
    finally {
        if ( conn != null ) try{conn.commit();}catch(Exception e){}
        if ( stmt != null ) try { stmt.close();}catch(Exception e){}
        if ( pstmt != null ) try { pstmt.close();}catch(Exception e){}
        if ( conn != null ) resource.release();
    }
    System.exit(0);
  }
}