/**
 * @(#) RequestmonAppCalc.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */
import java.io.*;
import java.sql.*;
import java.util.*;
import org.jsn.reqanalysis.db.*;

public class RequestmonAppCalc{

  private static java.text.SimpleDateFormat formater = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat formater2 = new java.text.SimpleDateFormat("yyyy-MM-dd-HH.mm.ss.000000");      
  public static void main(String[] args) throws Exception {
    if ( args.length < 4 ) {
        System.out.println("Usage: requestmonappcalc <starttime(yyyyMMdd/HHmmss)> <endtime(yyyyMMdd/HHmmss)> <interval(seconds)> <app_name> [<host>]");
        System.exit(1);
    }
    java.util.Date starttime = formater.parse(args[0]);
    java.util.Date endtime = formater.parse(args[1]);
    long interval = Long.parseLong(args[2]);
    String service = args[3];
    interval *= 1000;
    String host = null;
    if ( args.length > 4 ) {
      host = args[4];
    }
    ConnectionResource resource = null;
    Connection conn = null;
    Statement stmt = null;
    PreparedStatement pstmt = null;
    try {


        resource = new ConnectionResource();
        conn = resource.getConnection();
        stmt = conn.createStatement();

        java.sql.Timestamp start = new java.sql.Timestamp(starttime.getTime());
        java.sql.Timestamp end = new java.sql.Timestamp(start.getTime() + interval);
        while(true) {
            String sql = 
                   "select starttime, endtime  " + 
                   " from reqmonlog " +
                   " where not ( endtime < '" +  formater2.format(start) + "'  or '" +  formater2.format(end) + "' < starttime ) " +
                   " and shorturl = '" + service + "' ";
            if ( host != null ) sql += " and host = '" + host + "'";

            ResultSet rs = stmt.executeQuery(sql);

            long sum = 0L;
            while (rs.next()) {
                long s = Math.max(rs.getTimestamp(1).getTime(), start.getTime());
                long e = Math.min(rs.getTimestamp(2).getTime(), end.getTime());
                sum += (e-s);
            }
            System.out.println( formater.format(start) + "\t" + sum/1000 );
            start = end;
            end = new java.sql.Timestamp(start.getTime() + interval);
            if ( end.getTime() > endtime.getTime() ) break;
        }
    }
    catch(Exception e){
        System.out.println(e.toString());
    }
    finally {
        if ( stmt != null ) try { stmt.close();}catch(Exception e){}
        if ( conn != null ) resource.release();
    }
    System.exit(0);
  }
}