/**
 * @(#) RequestmonInsert.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */
import java.io.*;
import java.sql.*;
import java.util.*;
import org.jsn.reqanalysis.db.*;

public class RequestmonLoad{

  private static java.text.SimpleDateFormat formater = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");      
  private static java.text.SimpleDateFormat formater2 = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");      
  public static void main(String[] args) throws Exception {
    if ( args.length < 2 ) {
        System.out.println("Usage: requestmonload <trace.log> <host> [drop]");
        System.exit(1);
    }

    ConnectionResource resource = null;
    Connection conn = null;
    Statement stmt = null;
    PreparedStatement pstmt = null;
    try {
        resource = new ConnectionResource();
        conn = resource.getConnection();
        stmt = conn.createStatement();
        if ( args.length >= 3 && args[2].equals("drop") ) {
           try{
               stmt.executeUpdate("drop index REQMONLOG_IDX1");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop index REQMONLOG_IDX2");
           }
           catch(Exception e){}
           try{
               stmt.executeUpdate("drop table REQMONLOG");
               System.out.println("Table REQMONLOG droped");
           }
           catch(Exception e){}
           try{
              stmt.executeUpdate(
                "create table REQMONLOG(" +
                " host varchar(15) not null, " +
                " starttime timestamp not null, " +
                " endtime timestamp not null, " +
                " elapsed num(10) not null, " +
                " url varchar(3000) not null," +
                " shorturl varchar(100) )"
              );
              stmt.executeUpdate(
                "create index REQMONLOG_IDX1 " +
                "ON REQMONLOG(host,starttime,endtime)"
              );
              stmt.executeUpdate(
                "create index REQMONLOG_IDX2 " +
                "ON REQMONLOG(shorturl)"
              );
              System.out.println("Table REQMONLOG created");
           }
           catch(Exception e){
               System.out.println(e.toString());
           }
        }

        pstmt = conn.prepareStatement(
               "insert into REQMONLOG(host,starttime,endtime,elapsed,url,shorturl) "+
               "values(?,?,?,?,?,?)");

        File file = new File(args[0]);
        BufferedReader br = new BufferedReader(new FileReader(file));
        for(String line = br.readLine();line != null; line=br.readLine() ){
            String host = args[1];
            String a = null;
            String b = null;
            String url = null;
            String warning = null;
            String shorturl = null;
            StringTokenizer nizer = new StringTokenizer(line,":");
            try {
                nizer.hasMoreElements();
                a = nizer.nextToken();
                nizer.hasMoreElements();
                warning = nizer.nextToken();
                if ( ! warning.equals("WARNING") ) host = host+"_"+ warning;
                nizer.hasMoreElements();
                b = nizer.nextToken();
                nizer.hasMoreElements();
                // for ī(:: ߺ)
                //---------------------------------
                //nizer.nextToken();
                nizer.hasMoreElements();
                //---------------------------------
                url= nizer.nextToken();

                // for ī(IP)
                //---------------------------------
                if (warning.equals("WARNING")) {
                    int x = url.indexOf("/");
                    if ( x != -1 ) {
                        url = url.substring(x);
                    }
                }
                //---------------------------------

                int index = url.indexOf("?");
                if ( index == -1 ) shorturl = url;
                else {
                   shorturl = url.substring(0,index);
                }
            }
            catch (Exception e){
                System.out.println(e.toString());
                continue;
            }
            //System.out.println(a);
            long elapsed = Long.parseLong(b);
            java.util.Date end = formater.parse(a);
            // for HYUNDAI
            // end.setTime(end.getTime() + (9 * 3600 * 1000));
            //
            java.util.Date start = new java.util.Date(end.getTime() - elapsed);
            String tmpurl = ( url.length() > 30 )? url.substring(0,30) + "...": url;
            System.out.println(host + ":"+ formater.format(start)+":" +":"+elapsed + "\t" + tmpurl);

            try{
                pstmt.clearParameters();
                pstmt.setString(1, host);
                pstmt.setString(2, formater2.format(start));
                pstmt.setString(3, formater2.format(end));
                pstmt.setLong(4, elapsed);
                pstmt.setString(5, url);
                pstmt.setString(6, shorturl);
                pstmt.executeUpdate();
            }
            catch(Exception e){
                System.out.println(e);
                continue;
            }

        }
    }
    catch(Exception e){
        System.out.println(e.toString());
    }
    finally {
        if ( stmt != null ) try { stmt.close();}catch(Exception e){}
        if ( conn != null ) resource.release();
    }
    System.exit(0);
  }
}