package org.jsn.reqanalysis.db;

/**
 * @(#) EMPConnResource.java
 * Copyright 1999-2001 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 */

import com.lgeds.jdf.db.*;
import com.lgeds.jdf.jtx.TransactionalResourceManager;

public class ConnectionResource extends TransactionalResourceManager {
	private com.lgeds.jdf.db.pool.PoolConnection poolConnection = null;

	/**
	 * JDF Connection Pool : gov.mpbbis.pbf.db.emp.* in the pbf.properties file.
	 */
	public ConnectionResource() throws DBOpenException {
		super();
		try {
			com.lgeds.jdf.Config conf = new com.lgeds.jdf.Configuration();
			
			com.lgeds.jdf.db.pool.JdbcConnSpec spec =  
				new com.lgeds.jdf.db.pool.JdbcConnSpec(
					conf.get("org.jsn.reqanalysis.driver"),
					conf.get("org.jsn.reqanalysis.url"),
					conf.get("org.jsn.reqanalysis.user"),
					conf.get("org.jsn.reqanalysis.password")
				);
			com.lgeds.jdf.db.pool.ConnMgr mgr = 
				com.lgeds.jdf.db.pool.ConnMgrUtil.getConnMgr();
				
			this.poolConnection = mgr.getPoolConnection(spec);
			java.sql.Connection conn = poolConnection.getConnection();
			super.setConnection(conn);
		}
		catch(Exception e) {
			throw new DBOpenException(e.getMessage());
		}
	}

	/**
	 * @param ctx com.lgeds.jdf.db.ConnectionContext
	 */
	public ConnectionResource(ConnectionContext ctx) {
		super(ctx);
	}

	/**
	 * release connection into the connection pool.
	 */
	public void release() {
		try {
			if ( poolConnection == null ) return;
			poolConnection.release();
			poolConnection = null;
		}
		catch(Exception e){}
	}
}
